/* Generated with snc from EMU_MTR-CHECKBRAKE_snl.i */

/* Program "checkMTRBrake" */
#include <string.h>
#include <stddef.h>
#include <stdio.h>
#include <limits.h>
#include "epicsTypes.h"
#include "seqCom.h"

/* Variable declarations */
# line 13 "../.././src/EMU_MTR-CHECKBRAKE.st"
static	short ErrorBrakeMtrGet = 0;
# line 19 "../.././src/EMU_MTR-CHECKBRAKE.st"
static	short statusMTRMov = 0;
# line 23 "../.././src/EMU_MTR-CHECKBRAKE.st"
static	short ErrorBrakeMtrSet = 0;
# line 27 "../.././src/EMU_MTR-CHECKBRAKE.st"
static	short brakeMtrCMD = 0;
# line 31 "../.././src/EMU_MTR-CHECKBRAKE.st"
static	short brakeMtrGET = 0;
# line 37 "../.././src/EMU_MTR-CHECKBRAKE.st"
static	short AbortscanMtrCMD = 0;
# line 41 "../.././src/EMU_MTR-CHECKBRAKE.st"
static	short countErrors = 0;

/* C code definitions */
# line 8 "../.././src/EMU_MTR-CHECKBRAKE.st"
#include <stdio.h>
# line 9 "../.././src/EMU_MTR-CHECKBRAKE.st"
#include <string.h>
# line 10 "../.././src/EMU_MTR-CHECKBRAKE.st"
#include <stdlib.h>

/* Program init func */
static void G_prog_init(struct UserVar *pVar)
{
}

/****** Code for state "init" in state set "ss1" ******/

/* Delay function for state "init" in state set "ss1" */
static void D_ss1_0_init(SS_ID ssId, struct UserVar *pVar)
{
# line 46 "../.././src/EMU_MTR-CHECKBRAKE.st"
	seq_delayInit(ssId, 0, (1.0));
}

/* Event function for state "init" in state set "ss1" */
static seqBool E_ss1_0_init(SS_ID ssId, struct UserVar *pVar, int *pTransNum, int *pNextState)
{
# line 46 "../.././src/EMU_MTR-CHECKBRAKE.st"
	if (seq_delay(ssId, 0) && (seq_pvConnectCount(ssId) == seq_pvChannelCount(ssId)))
	{
		*pNextState = 1;
		*pTransNum = 0;
		return TRUE;
	}
	return FALSE;
}

/* Action function for state "init" in state set "ss1" */
static void A_ss1_0_init(SS_ID ssId, struct UserVar *pVar, int transNum, int *pNextState)
{
	switch(transNum)
	{
	case 0:
		{
# line 48 "../.././src/EMU_MTR-CHECKBRAKE.st"
			printf("\nWAIT\n");
# line 49 "../.././src/EMU_MTR-CHECKBRAKE.st"
			ErrorBrakeMtrSet = 0;
# line 50 "../.././src/EMU_MTR-CHECKBRAKE.st"
			seq_pvPut(ssId, 2/*ErrorBrakeMtrSet*/, 0);
		}
		return;
	}
}

/****** Code for state "waiting" in state set "ss1" ******/

/* Delay function for state "waiting" in state set "ss1" */
static void D_ss1_0_waiting(SS_ID ssId, struct UserVar *pVar)
{
# line 56 "../.././src/EMU_MTR-CHECKBRAKE.st"
	seq_delayInit(ssId, 0, (0.1));
}

/* Event function for state "waiting" in state set "ss1" */
static seqBool E_ss1_0_waiting(SS_ID ssId, struct UserVar *pVar, int *pTransNum, int *pNextState)
{
# line 56 "../.././src/EMU_MTR-CHECKBRAKE.st"
	if (seq_efTestAndClear(ssId, 1/*ErrorBrakeMtrEvent*/) && (ErrorBrakeMtrGet == 1) && (seq_delay(ssId, 0)))
	{
		*pNextState = 2;
		*pTransNum = 0;
		return TRUE;
	}
	return FALSE;
}

/* Action function for state "waiting" in state set "ss1" */
static void A_ss1_0_waiting(SS_ID ssId, struct UserVar *pVar, int transNum, int *pNextState)
{
	switch(transNum)
	{
	case 0:
		{
# line 58 "../.././src/EMU_MTR-CHECKBRAKE.st"
			printf("\nERRROR CURRENT : BRAKE OFF \n");
# line 59 "../.././src/EMU_MTR-CHECKBRAKE.st"
			brakeMtrCMD = 1;
# line 60 "../.././src/EMU_MTR-CHECKBRAKE.st"
			seq_pvPut(ssId, 3/*brakeMtrCMD*/, 0);
# line 61 "../.././src/EMU_MTR-CHECKBRAKE.st"
			seq_delay(ssId, 0);
# line 62 "../.././src/EMU_MTR-CHECKBRAKE.st"
			ErrorBrakeMtrSet = 0;
# line 63 "../.././src/EMU_MTR-CHECKBRAKE.st"
			seq_pvPut(ssId, 2/*ErrorBrakeMtrSet*/, 0);
		}
		return;
	}
}

/****** Code for state "count" in state set "ss1" ******/

/* Delay function for state "count" in state set "ss1" */
static void D_ss1_0_count(SS_ID ssId, struct UserVar *pVar)
{
# line 74 "../.././src/EMU_MTR-CHECKBRAKE.st"
	seq_delayInit(ssId, 0, (1.0));
# line 80 "../.././src/EMU_MTR-CHECKBRAKE.st"
	seq_delayInit(ssId, 1, (1.0));
}

/* Event function for state "count" in state set "ss1" */
static seqBool E_ss1_0_count(SS_ID ssId, struct UserVar *pVar, int *pTransNum, int *pNextState)
{
# line 69 "../.././src/EMU_MTR-CHECKBRAKE.st"
	if (countErrors > 3)
	{
		*pNextState = 3;
		*pTransNum = 0;
		return TRUE;
	}
# line 74 "../.././src/EMU_MTR-CHECKBRAKE.st"
	if ((seq_delay(ssId, 0)) && (statusMTRMov == 1))
	{
		*pNextState = 1;
		*pTransNum = 1;
		return TRUE;
	}
# line 80 "../.././src/EMU_MTR-CHECKBRAKE.st"
	if ((seq_delay(ssId, 1)) && (statusMTRMov == 0))
	{
		*pNextState = 1;
		*pTransNum = 2;
		return TRUE;
	}
	return FALSE;
}

/* Action function for state "count" in state set "ss1" */
static void A_ss1_0_count(SS_ID ssId, struct UserVar *pVar, int transNum, int *pNextState)
{
	switch(transNum)
	{
	case 0:
		{
# line 71 "../.././src/EMU_MTR-CHECKBRAKE.st"
			printf("\nERRROR CURRENT : STOP MEASURE \n");
		}
		return;
	case 1:
		{
# line 76 "../.././src/EMU_MTR-CHECKBRAKE.st"
			printf("\nERRROR CURRENT : PROBLEM SOLVED \n");
# line 77 "../.././src/EMU_MTR-CHECKBRAKE.st"
			countErrors = 0;
		}
		return;
	case 2:
		{
# line 82 "../.././src/EMU_MTR-CHECKBRAKE.st"
			countErrors = countErrors + 1;
		}
		return;
	}
}

/****** Code for state "stopMeasure" in state set "ss1" ******/

/* Delay function for state "stopMeasure" in state set "ss1" */
static void D_ss1_0_stopMeasure(SS_ID ssId, struct UserVar *pVar)
{
# line 89 "../.././src/EMU_MTR-CHECKBRAKE.st"
	seq_delayInit(ssId, 0, (1.0));
}

/* Event function for state "stopMeasure" in state set "ss1" */
static seqBool E_ss1_0_stopMeasure(SS_ID ssId, struct UserVar *pVar, int *pTransNum, int *pNextState)
{
# line 89 "../.././src/EMU_MTR-CHECKBRAKE.st"
	if (seq_delay(ssId, 0))
	{
		*pNextState = 1;
		*pTransNum = 0;
		return TRUE;
	}
	return FALSE;
}

/* Action function for state "stopMeasure" in state set "ss1" */
static void A_ss1_0_stopMeasure(SS_ID ssId, struct UserVar *pVar, int transNum, int *pNextState)
{
	switch(transNum)
	{
	case 0:
		{
# line 90 "../.././src/EMU_MTR-CHECKBRAKE.st"
			printf("\n ABORT\n");
# line 91 "../.././src/EMU_MTR-CHECKBRAKE.st"
			AbortscanMtrCMD = 1;
# line 92 "../.././src/EMU_MTR-CHECKBRAKE.st"
			seq_pvPut(ssId, 5/*AbortscanMtrCMD*/, 0);
# line 93 "../.././src/EMU_MTR-CHECKBRAKE.st"
			countErrors = 0;
		}
		return;
	}
}

/************************ Tables ************************/

/* Channel table */
static seqChan G_channels[] = {
	/* chName, offset, varName, varType, count, eventNum, efId, monitored, queueSize, queueIndex */
	{"{DEVICE}-PMAC:CURRENT_ERR_R", (size_t)&ErrorBrakeMtrGet, "ErrorBrakeMtrGet", "short", 1, 3, 1, 1, 0, 0},
	{"{PMACPREFIX}:{MOTOR_NAME}.MOVN", (size_t)&statusMTRMov, "statusMTRMov", "short", 1, 4, 0, 1, 0, 0},
	{"{DEVICE}-PMAC:CURRENT_ERR_S", (size_t)&ErrorBrakeMtrSet, "ErrorBrakeMtrSet", "short", 1, 5, 0, 1, 0, 0},
	{"{DEVICE}-PMAC:BRAKE_S", (size_t)&brakeMtrCMD, "brakeMtrCMD", "short", 1, 6, 0, 1, 0, 0},
	{"{DEVICE}-PMAC:BRAKE_R", (size_t)&brakeMtrGET, "brakeMtrGET", "short", 1, 7, 2, 1, 0, 0},
	{"{DEVICE}:MTR-ABORT.PROC", (size_t)&AbortscanMtrCMD, "AbortscanMtrCMD", "short", 1, 8, 0, 1, 0, 0}
};

/* Event masks for state set "ss1" */
static const seqMask	EM_ss1_0_init[] = {
	0x00000000,
};
static const seqMask	EM_ss1_0_waiting[] = {
	0x0000000a,
};
static const seqMask	EM_ss1_0_count[] = {
	0x00000010,
};
static const seqMask	EM_ss1_0_stopMeasure[] = {
	0x00000000,
};

/* State table for state set "ss1" */
static seqState G_ss1_states[] = {
	{
	/* state name */        "init",
	/* action function */   A_ss1_0_init,
	/* event function */    E_ss1_0_init,
	/* delay function */    D_ss1_0_init,
	/* entry function */    0,
	/* exit function */     0,
	/* event mask array */  EM_ss1_0_init,
	/* state options */     (0)
	},
	{
	/* state name */        "waiting",
	/* action function */   A_ss1_0_waiting,
	/* event function */    E_ss1_0_waiting,
	/* delay function */    D_ss1_0_waiting,
	/* entry function */    0,
	/* exit function */     0,
	/* event mask array */  EM_ss1_0_waiting,
	/* state options */     (0)
	},
	{
	/* state name */        "count",
	/* action function */   A_ss1_0_count,
	/* event function */    E_ss1_0_count,
	/* delay function */    D_ss1_0_count,
	/* entry function */    0,
	/* exit function */     0,
	/* event mask array */  EM_ss1_0_count,
	/* state options */     (0)
	},
	{
	/* state name */        "stopMeasure",
	/* action function */   A_ss1_0_stopMeasure,
	/* event function */    E_ss1_0_stopMeasure,
	/* delay function */    D_ss1_0_stopMeasure,
	/* entry function */    0,
	/* exit function */     0,
	/* event mask array */  EM_ss1_0_stopMeasure,
	/* state options */     (0)
	},
};

/* State set table */
static seqSS G_state_sets[] = {
	{
	/* state set name */    "ss1",
	/* states */            G_ss1_states,
	/* number of states */  4,
	/* number of delays */  2
	},
};

/* Program table (global) */
seqProgram checkMTRBrake = {
	/* magic number */      2001010,
	/* program name */      "checkMTRBrake",
	/* channels */          G_channels,
	/* num. channels */     6,
	/* state sets */        G_state_sets,
	/* num. state sets */   1,
	/* user var size */     0,
	/* param */             "",
	/* num. event flags */  2,
	/* encoded options */   (0 | OPT_CONN | OPT_NEWEF),
	/* init func */         G_prog_init,
	/* entry func */        NULL,
	/* exit func */         NULL,
	/* num. queues */       0
};

/* Register sequencer commands and program */
#include "epicsExport.h"
static void checkMTRBrakeRegistrar (void) {
    seqRegisterSequencerCommands();
    seqRegisterSequencerProgram (&checkMTRBrake);
}
epicsExportRegistrar(checkMTRBrakeRegistrar);
