/* Generated with snc from EMU_MTR-HOME_AUTO_snl.i */

/* Program "homeMtrAuto" */
#include <string.h>
#include <stddef.h>
#include <stdio.h>
#include <limits.h>
#include "epicsTypes.h"
#include "seqCom.h"

/* Variable declarations */
# line 13 "../.././src/EMU_MTR-HOME_AUTO.st"
static	short ARCHIVING = 0;
# line 18 "../.././src/EMU_MTR-HOME_AUTO.st"
static	short HOMCPTFLAG = 0;
# line 22 "../.././src/EMU_MTR-HOME_AUTO.st"
static	short statusMTRMov = 0;
# line 26 "../.././src/EMU_MTR-HOME_AUTO.st"
static	short mtrPlaced = 0;
# line 32 "../.././src/EMU_MTR-HOME_AUTO.st"
static	short mtrStop = 0;
# line 36 "../.././src/EMU_MTR-HOME_AUTO.st"
static	short homeCMD = 0;
# line 40 "../.././src/EMU_MTR-HOME_AUTO.st"
static	short mtrPosCons = 0;
# line 44 "../.././src/EMU_MTR-HOME_AUTO.st"
static	short brakeMtrCMD = 0;
# line 48 "../.././src/EMU_MTR-HOME_AUTO.st"
static	short brakeMtrGET = 0;
# line 55 "../.././src/EMU_MTR-HOME_AUTO.st"
static	short scanPS_Sts = 0;
# line 60 "../.././src/EMU_MTR-HOME_AUTO.st"
static	short scanMTR_Sts = 0;
# line 66 "../.././src/EMU_MTR-HOME_AUTO.st"
static	short homeSTART = 0;
# line 73 "../.././src/EMU_MTR-HOME_AUTO.st"
static	short plimSTATUS = 0;

/* C code definitions */
# line 8 "../.././src/EMU_MTR-HOME_AUTO.st"
#include <stdio.h>
# line 9 "../.././src/EMU_MTR-HOME_AUTO.st"
#include <string.h>
# line 10 "../.././src/EMU_MTR-HOME_AUTO.st"
#include <stdlib.h>

/* Program init func */
static void G_prog_init(struct UserVar *pVar)
{
}

/****** Code for state "init" in state set "ss1" ******/

/* Delay function for state "init" in state set "ss1" */
static void D_ss1_0_init(SS_ID ssId, struct UserVar *pVar)
{
# line 82 "../.././src/EMU_MTR-HOME_AUTO.st"
	seq_delayInit(ssId, 0, (1.0));
}

/* Event function for state "init" in state set "ss1" */
static seqBool E_ss1_0_init(SS_ID ssId, struct UserVar *pVar, int *pTransNum, int *pNextState)
{
# line 82 "../.././src/EMU_MTR-HOME_AUTO.st"
	if (seq_delay(ssId, 0) && (seq_pvConnectCount(ssId) == seq_pvChannelCount(ssId)))
	{
		*pNextState = 1;
		*pTransNum = 0;
		return TRUE;
	}
	return FALSE;
}

/* Action function for state "init" in state set "ss1" */
static void A_ss1_0_init(SS_ID ssId, struct UserVar *pVar, int transNum, int *pNextState)
{
	switch(transNum)
	{
	case 0:
		{
# line 84 "../.././src/EMU_MTR-HOME_AUTO.st"
			homeSTART = 0;
# line 85 "../.././src/EMU_MTR-HOME_AUTO.st"
			seq_pvPut(ssId, 11/*homeSTART*/, 0);
# line 86 "../.././src/EMU_MTR-HOME_AUTO.st"
			printf("\nWAIT\n");
		}
		return;
	}
}

/****** Code for state "waiting" in state set "ss1" ******/

/* Delay function for state "waiting" in state set "ss1" */
static void D_ss1_0_waiting(SS_ID ssId, struct UserVar *pVar)
{
}

/* Event function for state "waiting" in state set "ss1" */
static seqBool E_ss1_0_waiting(SS_ID ssId, struct UserVar *pVar, int *pTransNum, int *pNextState)
{
# line 92 "../.././src/EMU_MTR-HOME_AUTO.st"
	if (seq_efTestAndClear(ssId, 3/*homeSTARTEvent*/) && (homeSTART == 1) && (plimSTATUS == 0))
	{
		*pNextState = 2;
		*pTransNum = 0;
		return TRUE;
	}
	return FALSE;
}

/* Action function for state "waiting" in state set "ss1" */
static void A_ss1_0_waiting(SS_ID ssId, struct UserVar *pVar, int transNum, int *pNextState)
{
	switch(transNum)
	{
	case 0:
		{
# line 94 "../.././src/EMU_MTR-HOME_AUTO.st"
			printf("\nSTART HOME PROCEDURE\n");
		}
		return;
	}
}

/****** Code for state "startHOME" in state set "ss1" ******/

/* Delay function for state "startHOME" in state set "ss1" */
static void D_ss1_0_startHOME(SS_ID ssId, struct UserVar *pVar)
{
# line 101 "../.././src/EMU_MTR-HOME_AUTO.st"
	seq_delayInit(ssId, 0, (1.0));
}

/* Event function for state "startHOME" in state set "ss1" */
static seqBool E_ss1_0_startHOME(SS_ID ssId, struct UserVar *pVar, int *pTransNum, int *pNextState)
{
# line 101 "../.././src/EMU_MTR-HOME_AUTO.st"
	if ((scanPS_Sts == 0) && (scanMTR_Sts == 0) && (statusMTRMov == 0) && (seq_delay(ssId, 0)))
	{
		*pNextState = 3;
		*pTransNum = 0;
		return TRUE;
	}
	return FALSE;
}

/* Action function for state "startHOME" in state set "ss1" */
static void A_ss1_0_startHOME(SS_ID ssId, struct UserVar *pVar, int transNum, int *pNextState)
{
	switch(transNum)
	{
	case 0:
		{
# line 102 "../.././src/EMU_MTR-HOME_AUTO.st"
			printf("\n GO HOME\n");
# line 103 "../.././src/EMU_MTR-HOME_AUTO.st"
			brakeMtrCMD = 1;
# line 104 "../.././src/EMU_MTR-HOME_AUTO.st"
			seq_pvPut(ssId, 7/*brakeMtrCMD*/, 0);
# line 105 "../.././src/EMU_MTR-HOME_AUTO.st"
			seq_delay(ssId, 0);
# line 106 "../.././src/EMU_MTR-HOME_AUTO.st"
			HOMCPTFLAG = 1;
# line 107 "../.././src/EMU_MTR-HOME_AUTO.st"
			seq_pvPut(ssId, 1/*HOMCPTFLAG*/, 0);
# line 108 "../.././src/EMU_MTR-HOME_AUTO.st"
			seq_delay(ssId, 0);
# line 109 "../.././src/EMU_MTR-HOME_AUTO.st"
			homeCMD = 1;
# line 110 "../.././src/EMU_MTR-HOME_AUTO.st"
			seq_pvPut(ssId, 5/*homeCMD*/, 0);
		}
		return;
	}
}

/****** Code for state "limitON" in state set "ss1" ******/

/* Delay function for state "limitON" in state set "ss1" */
static void D_ss1_0_limitON(SS_ID ssId, struct UserVar *pVar)
{
}

/* Event function for state "limitON" in state set "ss1" */
static seqBool E_ss1_0_limitON(SS_ID ssId, struct UserVar *pVar, int *pTransNum, int *pNextState)
{
# line 116 "../.././src/EMU_MTR-HOME_AUTO.st"
	if (seq_efTestAndClear(ssId, 4/*plimSTATUSEvent*/) && (plimSTATUS == 1))
	{
		*pNextState = 4;
		*pTransNum = 0;
		return TRUE;
	}
	return FALSE;
}

/* Action function for state "limitON" in state set "ss1" */
static void A_ss1_0_limitON(SS_ID ssId, struct UserVar *pVar, int transNum, int *pNextState)
{
	switch(transNum)
	{
	case 0:
		{
# line 118 "../.././src/EMU_MTR-HOME_AUTO.st"
			printf("\nLIMIT HIGH\n");
# line 119 "../.././src/EMU_MTR-HOME_AUTO.st"
			HOMCPTFLAG = 0;
# line 120 "../.././src/EMU_MTR-HOME_AUTO.st"
			seq_pvPut(ssId, 1/*HOMCPTFLAG*/, 0);
		}
		return;
	}
}

/****** Code for state "breakON" in state set "ss1" ******/

/* Delay function for state "breakON" in state set "ss1" */
static void D_ss1_0_breakON(SS_ID ssId, struct UserVar *pVar)
{
# line 126 "../.././src/EMU_MTR-HOME_AUTO.st"
	seq_delayInit(ssId, 0, (1.0));
}

/* Event function for state "breakON" in state set "ss1" */
static seqBool E_ss1_0_breakON(SS_ID ssId, struct UserVar *pVar, int *pTransNum, int *pNextState)
{
# line 126 "../.././src/EMU_MTR-HOME_AUTO.st"
	if (seq_delay(ssId, 0))
	{
		*pNextState = 5;
		*pTransNum = 0;
		return TRUE;
	}
	return FALSE;
}

/* Action function for state "breakON" in state set "ss1" */
static void A_ss1_0_breakON(SS_ID ssId, struct UserVar *pVar, int transNum, int *pNextState)
{
	switch(transNum)
	{
	case 0:
		{
# line 128 "../.././src/EMU_MTR-HOME_AUTO.st"
			printf("\nINIT POSITION\n");
# line 129 "../.././src/EMU_MTR-HOME_AUTO.st"
			HOMCPTFLAG = 0;
# line 130 "../.././src/EMU_MTR-HOME_AUTO.st"
			seq_pvPut(ssId, 1/*HOMCPTFLAG*/, 0);
# line 131 "../.././src/EMU_MTR-HOME_AUTO.st"
			seq_delay(ssId, 0);
# line 132 "../.././src/EMU_MTR-HOME_AUTO.st"
			printf("\nBRAKE ON\n");
# line 133 "../.././src/EMU_MTR-HOME_AUTO.st"
			homeCMD = 1;
# line 134 "../.././src/EMU_MTR-HOME_AUTO.st"
			seq_pvPut(ssId, 5/*homeCMD*/, 0);
# line 135 "../.././src/EMU_MTR-HOME_AUTO.st"
			homeSTART = 0;
# line 136 "../.././src/EMU_MTR-HOME_AUTO.st"
			seq_pvPut(ssId, 11/*homeSTART*/, 0);
# line 137 "../.././src/EMU_MTR-HOME_AUTO.st"
			brakeMtrCMD = 0;
# line 138 "../.././src/EMU_MTR-HOME_AUTO.st"
			seq_pvPut(ssId, 7/*brakeMtrCMD*/, 0);
		}
		return;
	}
}

/****** Code for state "stopArchiving" in state set "ss1" ******/

/* Delay function for state "stopArchiving" in state set "ss1" */
static void D_ss1_0_stopArchiving(SS_ID ssId, struct UserVar *pVar)
{
# line 144 "../.././src/EMU_MTR-HOME_AUTO.st"
	seq_delayInit(ssId, 0, (2.0));
}

/* Event function for state "stopArchiving" in state set "ss1" */
static seqBool E_ss1_0_stopArchiving(SS_ID ssId, struct UserVar *pVar, int *pTransNum, int *pNextState)
{
# line 144 "../.././src/EMU_MTR-HOME_AUTO.st"
	if (seq_delay(ssId, 0))
	{
		*pNextState = 0;
		*pTransNum = 0;
		return TRUE;
	}
	return FALSE;
}

/* Action function for state "stopArchiving" in state set "ss1" */
static void A_ss1_0_stopArchiving(SS_ID ssId, struct UserVar *pVar, int transNum, int *pNextState)
{
	switch(transNum)
	{
	case 0:
		{
# line 146 "../.././src/EMU_MTR-HOME_AUTO.st"
			printf("\nStop Archiving\n");
# line 147 "../.././src/EMU_MTR-HOME_AUTO.st"
			ARCHIVING = 0;
# line 148 "../.././src/EMU_MTR-HOME_AUTO.st"
			seq_pvPut(ssId, 0/*ARCHIVING*/, 0);
		}
		return;
	}
}

/************************ Tables ************************/

/* Channel table */
static seqChan G_channels[] = {
	/* chName, offset, varName, varType, count, eventNum, efId, monitored, queueSize, queueIndex */
	{"{DEVICE}:Archive", (size_t)&ARCHIVING, "ARCHIVING", "short", 1, 5, 0, 1, 0, 0},
	{"{PMACPREFIX}:{MOTOR_NAME}-HOMCPTFLAG", (size_t)&HOMCPTFLAG, "HOMCPTFLAG", "short", 1, 6, 0, 1, 0, 0},
	{"{PMACPREFIX}:{MOTOR_NAME}.MOVN", (size_t)&statusMTRMov, "statusMTRMov", "short", 1, 7, 0, 1, 0, 0},
	{"{PMACPREFIX}:{MOTOR_NAME}-AXISSTS", (size_t)&mtrPlaced, "mtrPlaced", "short", 1, 8, 1, 1, 0, 0},
	{"{PMACPREFIX}:{MOTOR_NAME}.SPMG", (size_t)&mtrStop, "mtrStop", "short", 1, 9, 0, 1, 0, 0},
	{"{PMACPREFIX}:{MOTOR_NAME}-HOMCMD", (size_t)&homeCMD, "homeCMD", "short", 1, 10, 0, 1, 0, 0},
	{"{PMACPREFIX}:{MOTOR_NAME}", (size_t)&mtrPosCons, "mtrPosCons", "short", 1, 11, 0, 1, 0, 0},
	{"{DEVICE}-PMAC:BRAKE_S", (size_t)&brakeMtrCMD, "brakeMtrCMD", "short", 1, 12, 0, 1, 0, 0},
	{"{DEVICE}-PMAC:BRAKE_R", (size_t)&brakeMtrGET, "brakeMtrGET", "short", 1, 13, 2, 1, 0, 0},
	{"{DEVICE}:PS.BUSY", (size_t)&scanPS_Sts, "scanPS_Sts", "short", 1, 14, 0, 1, 0, 0},
	{"{DEVICE}:MTR.BUSY", (size_t)&scanMTR_Sts, "scanMTR_Sts", "short", 1, 15, 0, 1, 0, 0},
	{"{DEVICE}:PROC-AUTO-HOME", (size_t)&homeSTART, "homeSTART", "short", 1, 16, 3, 1, 0, 0},
	{"{PMACPREFIX}:{MOTOR_NAME}-PENDLSTS", (size_t)&plimSTATUS, "plimSTATUS", "short", 1, 17, 4, 1, 0, 0}
};

/* Event masks for state set "ss1" */
static const seqMask	EM_ss1_0_init[] = {
	0x00000000,
};
static const seqMask	EM_ss1_0_waiting[] = {
	0x00030008,
};
static const seqMask	EM_ss1_0_startHOME[] = {
	0x0000c080,
};
static const seqMask	EM_ss1_0_limitON[] = {
	0x00020010,
};
static const seqMask	EM_ss1_0_breakON[] = {
	0x00000000,
};
static const seqMask	EM_ss1_0_stopArchiving[] = {
	0x00000000,
};

/* State table for state set "ss1" */
static seqState G_ss1_states[] = {
	{
	/* state name */        "init",
	/* action function */   A_ss1_0_init,
	/* event function */    E_ss1_0_init,
	/* delay function */    D_ss1_0_init,
	/* entry function */    0,
	/* exit function */     0,
	/* event mask array */  EM_ss1_0_init,
	/* state options */     (0)
	},
	{
	/* state name */        "waiting",
	/* action function */   A_ss1_0_waiting,
	/* event function */    E_ss1_0_waiting,
	/* delay function */    D_ss1_0_waiting,
	/* entry function */    0,
	/* exit function */     0,
	/* event mask array */  EM_ss1_0_waiting,
	/* state options */     (0)
	},
	{
	/* state name */        "startHOME",
	/* action function */   A_ss1_0_startHOME,
	/* event function */    E_ss1_0_startHOME,
	/* delay function */    D_ss1_0_startHOME,
	/* entry function */    0,
	/* exit function */     0,
	/* event mask array */  EM_ss1_0_startHOME,
	/* state options */     (0)
	},
	{
	/* state name */        "limitON",
	/* action function */   A_ss1_0_limitON,
	/* event function */    E_ss1_0_limitON,
	/* delay function */    D_ss1_0_limitON,
	/* entry function */    0,
	/* exit function */     0,
	/* event mask array */  EM_ss1_0_limitON,
	/* state options */     (0)
	},
	{
	/* state name */        "breakON",
	/* action function */   A_ss1_0_breakON,
	/* event function */    E_ss1_0_breakON,
	/* delay function */    D_ss1_0_breakON,
	/* entry function */    0,
	/* exit function */     0,
	/* event mask array */  EM_ss1_0_breakON,
	/* state options */     (0)
	},
	{
	/* state name */        "stopArchiving",
	/* action function */   A_ss1_0_stopArchiving,
	/* event function */    E_ss1_0_stopArchiving,
	/* delay function */    D_ss1_0_stopArchiving,
	/* entry function */    0,
	/* exit function */     0,
	/* event mask array */  EM_ss1_0_stopArchiving,
	/* state options */     (0)
	},
};

/* State set table */
static seqSS G_state_sets[] = {
	{
	/* state set name */    "ss1",
	/* states */            G_ss1_states,
	/* number of states */  6,
	/* number of delays */  1
	},
};

/* Program table (global) */
seqProgram homeMtrAuto = {
	/* magic number */      2001010,
	/* program name */      "homeMtrAuto",
	/* channels */          G_channels,
	/* num. channels */     13,
	/* state sets */        G_state_sets,
	/* num. state sets */   1,
	/* user var size */     0,
	/* param */             "",
	/* num. event flags */  4,
	/* encoded options */   (0 | OPT_CONN | OPT_NEWEF),
	/* init func */         G_prog_init,
	/* entry func */        NULL,
	/* exit func */         NULL,
	/* num. queues */       0
};

/* Register sequencer commands and program */
#include "epicsExport.h"
static void homeMtrAutoRegistrar (void) {
    seqRegisterSequencerCommands();
    seqRegisterSequencerProgram (&homeMtrAuto);
}
epicsExportRegistrar(homeMtrAutoRegistrar);
